<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for POIInsert StructType
 * @subpackage Structs
 */
class POIInsert extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The StreetLine1
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $StreetLine1;
    /**
     * The StreetLine2
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $StreetLine2;
    /**
     * The StreetLine3
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $StreetLine3;
    /**
     * The Number
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Number;
    /**
     * The POBox
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $POBox;
    /**
     * The ZipCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ZipCode;
    /**
     * The City
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $City;
    /**
     * The CountryCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CountryCode;
    /**
     * The Position
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Position
     */
    public $Position;
    /**
     * The ContactPerson
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\POIContactPerson
     */
    public $ContactPerson;
    /**
     * The OpeningHours
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OpeningHours
     */
    public $OpeningHours;
    /**
     * The ExtraInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ExtraInformation;
    /**
     * Constructor method for POIInsert
     * @uses POIInsert::setName()
     * @uses POIInsert::setStreetLine1()
     * @uses POIInsert::setStreetLine2()
     * @uses POIInsert::setStreetLine3()
     * @uses POIInsert::setNumber()
     * @uses POIInsert::setPOBox()
     * @uses POIInsert::setZipCode()
     * @uses POIInsert::setCity()
     * @uses POIInsert::setCountryCode()
     * @uses POIInsert::setPosition()
     * @uses POIInsert::setContactPerson()
     * @uses POIInsert::setOpeningHours()
     * @uses POIInsert::setExtraInformation()
     * @param string $name
     * @param string $streetLine1
     * @param string $streetLine2
     * @param string $streetLine3
     * @param string $number
     * @param string $pOBox
     * @param string $zipCode
     * @param string $city
     * @param string $countryCode
     * @param \StructType\Position $position
     * @param \StructType\POIContactPerson $contactPerson
     * @param \StructType\OpeningHours $openingHours
     * @param string $extraInformation
     */
    public function __construct($name = null, $streetLine1 = null, $streetLine2 = null, $streetLine3 = null, $number = null, $pOBox = null, $zipCode = null, $city = null, $countryCode = null, \StructType\Position $position = null, \StructType\POIContactPerson $contactPerson = null, \StructType\OpeningHours $openingHours = null, $extraInformation = null)
    {
        $this
            ->setName($name)
            ->setStreetLine1($streetLine1)
            ->setStreetLine2($streetLine2)
            ->setStreetLine3($streetLine3)
            ->setNumber($number)
            ->setPOBox($pOBox)
            ->setZipCode($zipCode)
            ->setCity($city)
            ->setCountryCode($countryCode)
            ->setPosition($position)
            ->setContactPerson($contactPerson)
            ->setOpeningHours($openingHours)
            ->setExtraInformation($extraInformation);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\POIInsert
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get StreetLine1 value
     * @return string|null
     */
    public function getStreetLine1()
    {
        return $this->StreetLine1;
    }
    /**
     * Set StreetLine1 value
     * @param string $streetLine1
     * @return \StructType\POIInsert
     */
    public function setStreetLine1($streetLine1 = null)
    {
        // validation for constraint: string
        if (!is_null($streetLine1) && !is_string($streetLine1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($streetLine1, true), gettype($streetLine1)), __LINE__);
        }
        $this->StreetLine1 = $streetLine1;
        return $this;
    }
    /**
     * Get StreetLine2 value
     * @return string|null
     */
    public function getStreetLine2()
    {
        return $this->StreetLine2;
    }
    /**
     * Set StreetLine2 value
     * @param string $streetLine2
     * @return \StructType\POIInsert
     */
    public function setStreetLine2($streetLine2 = null)
    {
        // validation for constraint: string
        if (!is_null($streetLine2) && !is_string($streetLine2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($streetLine2, true), gettype($streetLine2)), __LINE__);
        }
        $this->StreetLine2 = $streetLine2;
        return $this;
    }
    /**
     * Get StreetLine3 value
     * @return string|null
     */
    public function getStreetLine3()
    {
        return $this->StreetLine3;
    }
    /**
     * Set StreetLine3 value
     * @param string $streetLine3
     * @return \StructType\POIInsert
     */
    public function setStreetLine3($streetLine3 = null)
    {
        // validation for constraint: string
        if (!is_null($streetLine3) && !is_string($streetLine3)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($streetLine3, true), gettype($streetLine3)), __LINE__);
        }
        $this->StreetLine3 = $streetLine3;
        return $this;
    }
    /**
     * Get Number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param string $number
     * @return \StructType\POIInsert
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($number, true), gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get POBox value
     * @return string|null
     */
    public function getPOBox()
    {
        return $this->POBox;
    }
    /**
     * Set POBox value
     * @param string $pOBox
     * @return \StructType\POIInsert
     */
    public function setPOBox($pOBox = null)
    {
        // validation for constraint: string
        if (!is_null($pOBox) && !is_string($pOBox)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pOBox, true), gettype($pOBox)), __LINE__);
        }
        $this->POBox = $pOBox;
        return $this;
    }
    /**
     * Get ZipCode value
     * @return string|null
     */
    public function getZipCode()
    {
        return $this->ZipCode;
    }
    /**
     * Set ZipCode value
     * @param string $zipCode
     * @return \StructType\POIInsert
     */
    public function setZipCode($zipCode = null)
    {
        // validation for constraint: string
        if (!is_null($zipCode) && !is_string($zipCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipCode, true), gettype($zipCode)), __LINE__);
        }
        $this->ZipCode = $zipCode;
        return $this;
    }
    /**
     * Get City value
     * @return string|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param string $city
     * @return \StructType\POIInsert
     */
    public function setCity($city = null)
    {
        // validation for constraint: string
        if (!is_null($city) && !is_string($city)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($city, true), gettype($city)), __LINE__);
        }
        $this->City = $city;
        return $this;
    }
    /**
     * Get CountryCode value
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->CountryCode;
    }
    /**
     * Set CountryCode value
     * @param string $countryCode
     * @return \StructType\POIInsert
     */
    public function setCountryCode($countryCode = null)
    {
        // validation for constraint: string
        if (!is_null($countryCode) && !is_string($countryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryCode, true), gettype($countryCode)), __LINE__);
        }
        $this->CountryCode = $countryCode;
        return $this;
    }
    /**
     * Get Position value
     * @return \StructType\Position|null
     */
    public function getPosition()
    {
        return $this->Position;
    }
    /**
     * Set Position value
     * @param \StructType\Position $position
     * @return \StructType\POIInsert
     */
    public function setPosition(\StructType\Position $position = null)
    {
        $this->Position = $position;
        return $this;
    }
    /**
     * Get ContactPerson value
     * @return \StructType\POIContactPerson|null
     */
    public function getContactPerson()
    {
        return $this->ContactPerson;
    }
    /**
     * Set ContactPerson value
     * @param \StructType\POIContactPerson $contactPerson
     * @return \StructType\POIInsert
     */
    public function setContactPerson(\StructType\POIContactPerson $contactPerson = null)
    {
        $this->ContactPerson = $contactPerson;
        return $this;
    }
    /**
     * Get OpeningHours value
     * @return \StructType\OpeningHours|null
     */
    public function getOpeningHours()
    {
        return $this->OpeningHours;
    }
    /**
     * Set OpeningHours value
     * @param \StructType\OpeningHours $openingHours
     * @return \StructType\POIInsert
     */
    public function setOpeningHours(\StructType\OpeningHours $openingHours = null)
    {
        $this->OpeningHours = $openingHours;
        return $this;
    }
    /**
     * Get ExtraInformation value
     * @return string|null
     */
    public function getExtraInformation()
    {
        return $this->ExtraInformation;
    }
    /**
     * Set ExtraInformation value
     * @param string $extraInformation
     * @return \StructType\POIInsert
     */
    public function setExtraInformation($extraInformation = null)
    {
        // validation for constraint: string
        if (!is_null($extraInformation) && !is_string($extraInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($extraInformation, true), gettype($extraInformation)), __LINE__);
        }
        $this->ExtraInformation = $extraInformation;
        return $this;
    }
}
